You are viewing a plain text version of this content. The canonical link for it is here.
Posted to github@arrow.apache.org by GitBox <gi...@apache.org> on 2021/04/28 17:29:42 UTC

[GitHub] [arrow] anthonylouisbsb opened a new pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

anthonylouisbsb opened a new pull request #10189:
URL: https://github.com/apache/arrow/pull/10189


   Today, there are two different tasks that generate Gandiva's jars for MacOS and Linux. The objective is to create a single jar with the shared lib for the two operating systems.


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564632



##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}

Review comment:
       I put just to generate a unique artifact name, but I think it is not necessary, I removed it.




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] kou commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
kou commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-830404815


   @github-actions crossbow submit gandiva-jar


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564341



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"
+
+if [[ $CHECK_SHARED_DEPENDENCIES ]] ; then
+    # exit if any shared library not in whitelisted set is found
+    echo "Checking shared dependencies"
+    while read -r line
+    do
+        found=false
+        for item in "${WHITELIST[@]}"
+        do
+        if [[ "$line" == *"$item"* ]] ; then
+            found=true
+        fi
+        done
+        if [[ "$found" == false ]] ; then
+        echo "Unexpected shared dependency found"
+        exit 1
+        fi
+    done < <(eval "$SO_DEP" "$GANDIVA_LIB" | awk '{print $1}')

Review comment:
       It is a good idea. Suggestion applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564681



##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so

Review comment:
       Change applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623566265



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"

Review comment:
       sugestion applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564808



##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so
+  build-cpp-macos:
+    name: Build C++ Gandiva Libs MacOS
+    runs-on: macos-latest
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          cd arrow
+          mkdir -p dist
+          export ARROW_TEST_DATA=$PWD/testing/data
+          set -e
+          dev/tasks/gandiva-jars/build-cpp-osx.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "osx"
+          CHECK_SHARED_DEPENDENCIES: true
+          MACOSX_DEPLOYMENT_TARGET: "10.11"
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.dylib
+  package-jar:
+    name: Build Gandiva Jar
+    runs-on: macos-latest
+    needs: [build-cpp-macos, build-cpp-ubuntu]
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+          mkdir -p arrow/dist
+      - name: Download Linux Gandiva Library
+        uses: actions/download-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist

Review comment:
       change applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] kou closed pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
kou closed pull request #10189:
URL: https://github.com/apache/arrow/pull/10189


   


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564098



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"

Review comment:
       Changes applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564742



##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so
+  build-cpp-macos:
+    name: Build C++ Gandiva Libs MacOS
+    runs-on: macos-latest
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          cd arrow
+          mkdir -p dist
+          export ARROW_TEST_DATA=$PWD/testing/data
+          set -e
+          dev/tasks/gandiva-jars/build-cpp-osx.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "osx"
+          CHECK_SHARED_DEPENDENCIES: true
+          MACOSX_DEPLOYMENT_TARGET: "10.11"
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.dylib

Review comment:
       change applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] projjal commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
projjal commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-829033658


   @github-actions crossbow submit -g gandiva-jar


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] kou commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
kou commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623385104



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"

Review comment:
       It seem that this `eval` is redundant:
   
   ```suggestion
   $SO_DEP "$GANDIVA_LIB"
   ```

##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"
+
+if [[ $CHECK_SHARED_DEPENDENCIES ]] ; then
+    # exit if any shared library not in whitelisted set is found
+    echo "Checking shared dependencies"
+    while read -r line
+    do
+        found=false
+        for item in "${WHITELIST[@]}"
+        do
+        if [[ "$line" == *"$item"* ]] ; then
+            found=true
+        fi
+        done
+        if [[ "$found" == false ]] ; then
+        echo "Unexpected shared dependency found"
+        exit 1

Review comment:
       Could you indent them?
   
   ```suggestion
               echo "Unexpected shared dependency found"
               exit 1
   ```

##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash

Review comment:
       Could you use `-` instead of `_` as word separator in file name?
   Because existing `build-java.sh` uses `-`.
   
   `check-shared-dependencies.sh`

##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so
+  build-cpp-macos:
+    name: Build C++ Gandiva Libs MacOS
+    runs-on: macos-latest
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          cd arrow
+          mkdir -p dist
+          export ARROW_TEST_DATA=$PWD/testing/data
+          set -e
+          dev/tasks/gandiva-jars/build-cpp-osx.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "osx"
+          CHECK_SHARED_DEPENDENCIES: true
+          MACOSX_DEPLOYMENT_TARGET: "10.11"
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.dylib
+  package-jar:
+    name: Build Gandiva Jar
+    runs-on: macos-latest
+    needs: [build-cpp-macos, build-cpp-ubuntu]
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+          mkdir -p arrow/dist
+      - name: Download Linux Gandiva Library
+        uses: actions/download-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist
+      - name: Download MacOS Gandiva Library
+        uses: actions/download-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist

Review comment:
       Ditto.

##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so
+  build-cpp-macos:
+    name: Build C++ Gandiva Libs MacOS
+    runs-on: macos-latest
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          cd arrow
+          mkdir -p dist
+          export ARROW_TEST_DATA=$PWD/testing/data
+          set -e
+          dev/tasks/gandiva-jars/build-cpp-osx.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "osx"
+          CHECK_SHARED_DEPENDENCIES: true
+          MACOSX_DEPLOYMENT_TARGET: "10.11"
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.dylib

Review comment:
       Ditto.

##########
File path: dev/tasks/tasks.yml
##########
@@ -1137,15 +1137,9 @@ tasks:
 
   ############################## Gandiva Tasks ################################
 
-  gandiva-jar-ubuntu:
+  gandiva-jar:
     ci: github
-    template: gandiva-jars/github.linux.yml
-    artifacts:
-      - arrow-gandiva-{no_rc_version}-SNAPSHOT.jar
-
-  gandiva-jar-osx:
-    ci: github
-    template: gandiva-jars/github.osx.yml
+    template: gandiva-jars/github.linux.macos.yml

Review comment:
       We can omit platform name from file name:
   
   ```suggestion
       template: gandiva-jars/github.yml
   ```

##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd

Review comment:
       Could you use 2 spaces for indent? Because existing `build-java.sh` uses 2 spaces.

##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so
+  build-cpp-macos:
+    name: Build C++ Gandiva Libs MacOS
+    runs-on: macos-latest
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          cd arrow
+          mkdir -p dist
+          export ARROW_TEST_DATA=$PWD/testing/data
+          set -e
+          dev/tasks/gandiva-jars/build-cpp-osx.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "osx"
+          CHECK_SHARED_DEPENDENCIES: true
+          MACOSX_DEPLOYMENT_TARGET: "10.11"
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.dylib
+  package-jar:
+    name: Build Gandiva Jar
+    runs-on: macos-latest
+    needs: [build-cpp-macos, build-cpp-ubuntu]
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+          mkdir -p arrow/dist
+      - name: Download Linux Gandiva Library
+        uses: actions/download-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist

Review comment:
       It seems that `{{ '${{ github.workspace }}' }}/` is redundant:
   
   ```suggestion
             path: arrow/dist
   ```

##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"
+
+if [[ $CHECK_SHARED_DEPENDENCIES ]] ; then
+    # exit if any shared library not in whitelisted set is found
+    echo "Checking shared dependencies"
+    while read -r line
+    do
+        found=false
+        for item in "${WHITELIST[@]}"
+        do
+        if [[ "$line" == *"$item"* ]] ; then
+            found=true
+        fi
+        done
+        if [[ "$found" == false ]] ; then
+        echo "Unexpected shared dependency found"
+        exit 1
+        fi
+    done < <(eval "$SO_DEP" "$GANDIVA_LIB" | awk '{print $1}')

Review comment:
       Can we unify multiple `$SO_DEP $GANDIVA_LIB`?
   
   ```shell
   # print and store the shared library dependencies
   $SO_DEP "$GANDIVA_LIB" | tee dependencies.txt
   # ...
       awk '{print $1}' dependencies.txt | while read -r line
       # ...
   
   ```

##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so

Review comment:
       It seems that `{{ '${{ github.workspace }}' }}/` is redundant:
   
   ```suggestion
             path: arrow/dist/libgandiva_jni.so
   ```

##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}

Review comment:
       Why do we need `-{{ '${{ github.sha }}' }}`?




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623565132



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash

Review comment:
       The suggestion was applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564168



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"
+
+if [[ $CHECK_SHARED_DEPENDENCIES ]] ; then
+    # exit if any shared library not in whitelisted set is found
+    echo "Checking shared dependencies"
+    while read -r line
+    do
+        found=false
+        for item in "${WHITELIST[@]}"
+        do
+        if [[ "$line" == *"$item"* ]] ; then
+            found=true
+        fi
+        done
+        if [[ "$found" == false ]] ; then
+        echo "Unexpected shared dependency found"
+        exit 1

Review comment:
       changes applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] github-actions[bot] commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
github-actions[bot] commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-830405385


   Revision: f7ae1632c31a955fd78a45b029508f766cc2cb76
   
   Submitted crossbow builds: [ursacomputing/crossbow @ actions-363](https://github.com/ursacomputing/crossbow/branches/all?query=actions-363)
   
   |Task|Status|
   |----|------|
   |gandiva-jar|[![Github Actions](https://github.com/ursacomputing/crossbow/workflows/Crossbow/badge.svg?branch=actions-363-github-gandiva-jar)](https://github.com/ursacomputing/crossbow/actions?query=branch:actions-363-github-gandiva-jar)|


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-834835885


   > Thanks!
   > 
   > I hope that we also build all other Java packages building in our release process ( https://github.com/apache/arrow/blob/master/dev/release/post-11-java.sh ) like this as the next task. We can just upload all Java packages including the Gandiva Java package in our release process by the next task.
   
   @kou I am interested in executing that task. Is there some opened JIRA ticket for it? Or should I create a new one?


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623566336



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.so
+    WHITELIST=(linux-vdso libz librt libdl libpthread libstdc++ libm libgcc_s libc ld-linux-x86-64)
+else
+    SO_DEP="otool -L"
+    GANDIVA_LIB="$CPP_BUILD_DIR"libgandiva_jni.dylib
+    WHITELIST=(libgandiva_jni libz libncurses libSystem libc++)
+fi
+
+# print the shared library dependencies
+eval "$SO_DEP" "$GANDIVA_LIB"
+
+if [[ $CHECK_SHARED_DEPENDENCIES ]] ; then
+    # exit if any shared library not in whitelisted set is found
+    echo "Checking shared dependencies"
+    while read -r line
+    do
+        found=false
+        for item in "${WHITELIST[@]}"
+        do
+        if [[ "$line" == *"$item"* ]] ; then
+            found=true
+        fi
+        done
+        if [[ "$found" == false ]] ; then
+        echo "Unexpected shared dependency found"
+        exit 1

Review comment:
       suggestion applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] github-actions[bot] commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
github-actions[bot] commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-828640500


   https://issues.apache.org/jira/browse/ARROW-12591


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623565004



##########
File path: dev/tasks/gandiva-jars/check_shared_dependencies.sh
##########
@@ -0,0 +1,54 @@
+#!/bin/bash
+
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+set -e
+
+CPP_BUILD_DIR=$GITHUB_WORKSPACE/arrow/dist/
+
+if [[ $OS_NAME == "linux" ]]; then
+    SO_DEP=ldd

Review comment:
       I changed the indentation for the file to use 2-spaces.




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-829783669


   @kou All suggestions were applied.


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-835048910


   @kou I created the JIRA issue https://issues.apache.org/jira/browse/ARROW-12699.
   
   I will start to work on it.


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] projjal commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
projjal commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-829083832


   @github-actions crossbow submit -g gandiva
   


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] kou commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
kou commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-835034969


   Great!
   
   Could you create a new JIRA issue for it?
   The new JIRA issue is a child of ARROW-11135 like ARROW-12591.
   
   In the task, we need to do the followings:
   
   1. Rename the `gandiva-jar` task to `java-jar`
   2. Build all Java packages in the task
   
   We'll update https://github.com/apache/arrow/blob/master/dev/release/post-11-java.sh and related release related scripts after the task.


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564431



##########
File path: dev/tasks/tasks.yml
##########
@@ -1137,15 +1137,9 @@ tasks:
 
   ############################## Gandiva Tasks ################################
 
-  gandiva-jar-ubuntu:
+  gandiva-jar:
     ci: github
-    template: gandiva-jars/github.linux.yml
-    artifacts:
-      - arrow-gandiva-{no_rc_version}-SNAPSHOT.jar
-
-  gandiva-jar-osx:
-    ci: github
-    template: gandiva-jars/github.osx.yml
+    template: gandiva-jars/github.linux.macos.yml

Review comment:
       Name changed.




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] anthonylouisbsb commented on a change in pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
anthonylouisbsb commented on a change in pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#discussion_r623564870



##########
File path: dev/tasks/gandiva-jars/github.linux.macos.yml
##########
@@ -0,0 +1,111 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements.  See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership.  The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License.  You may obtain a copy of the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied.  See the License for the
+# specific language governing permissions and limitations
+# under the License.
+
+{% import 'macros.jinja' as macros with context %}
+
+{{ macros.github_header() }}
+
+jobs:
+  build-cpp-ubuntu:
+    name: Build C++ Gandiva Libs Ubuntu
+    runs-on: ubuntu-18.04
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          python3 -VV
+          cd arrow
+          mkdir -p dist
+          export CC="gcc-4.9" CXX="g++-4.9"
+          ulimit -c unlimited -S
+          set -e
+          docker run -v $PWD:/arrow quay.io/anthonylouisbsb/arrow:gandivadocker /arrow/dev/tasks/gandiva-jars/build-cpp-linux.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "linux"
+          CHECK_SHARED_DEPENDENCIES: true
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.so
+  build-cpp-macos:
+    name: Build C++ Gandiva Libs MacOS
+    runs-on: macos-latest
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+      - name: Build Gandiva
+        run: |
+          cd arrow
+          mkdir -p dist
+          export ARROW_TEST_DATA=$PWD/testing/data
+          set -e
+          dev/tasks/gandiva-jars/build-cpp-osx.sh
+          dev/tasks/gandiva-jars/check_shared_dependencies.sh
+        env:
+          OS_NAME: "osx"
+          CHECK_SHARED_DEPENDENCIES: true
+          MACOSX_DEPLOYMENT_TARGET: "10.11"
+      - name: Upload Artifacts
+        uses: actions/upload-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist/libgandiva_jni.dylib
+  package-jar:
+    name: Build Gandiva Jar
+    runs-on: macos-latest
+    needs: [build-cpp-macos, build-cpp-ubuntu]
+    steps:
+      - name: Checkout Arrow
+        run: |
+          git clone --no-checkout {{ arrow.remote }} arrow
+          git -C arrow fetch -t {{ arrow.remote }} {{ arrow.branch }}
+          if [ $CROSSBOW_USE_COMMIT_ID = true ]; then git -C arrow checkout {{ arrow.head }}; else git -C arrow checkout FETCH_HEAD; fi
+          git -C arrow submodule update --init --recursive
+          mkdir -p arrow/dist
+      - name: Download Linux Gandiva Library
+        uses: actions/download-artifact@v2
+        with:
+          name: ubuntu-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist
+      - name: Download MacOS Gandiva Library
+        uses: actions/download-artifact@v2
+        with:
+          name: macos-shared-lib-{{ '${{ github.sha }}' }}
+          path: {{ '${{ github.workspace }}' }}/arrow/dist

Review comment:
       change applied




-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org



[GitHub] [arrow] github-actions[bot] commented on pull request #10189: ARROW-12591: [Java][Gandiva] Create single Gandiva jar for MacOS and Linux

Posted by GitBox <gi...@apache.org>.
github-actions[bot] commented on pull request #10189:
URL: https://github.com/apache/arrow/pull/10189#issuecomment-829084385


   Revision: cc5d9540b7e72969fa4997a168460eb93b649041
   
   Submitted crossbow builds: [ursacomputing/crossbow @ actions-354](https://github.com/ursacomputing/crossbow/branches/all?query=actions-354)
   
   |Task|Status|
   |----|------|
   |gandiva-jar|[![Github Actions](https://github.com/ursacomputing/crossbow/workflows/Crossbow/badge.svg?branch=actions-354-github-gandiva-jar)](https://github.com/ursacomputing/crossbow/actions?query=branch:actions-354-github-gandiva-jar)|


-- 
This is an automated message from the Apache Git Service.
To respond to the message, please log on to GitHub and use the
URL above to go to the specific comment.

For queries about this service, please contact Infrastructure at:
users@infra.apache.org